$fn = 30;
er=1.018; // expansion rate to counter ABS shrinkage
boxlength=100.6*er;
boxwidth=83.3*er;
boxheight=17.5;  // 12.8 serial height + 1.6mm PCB + 3mm stand off height = 17.9 -0.4
boxthickness=8*0.44;
boxbottom=2;
standoffheight=3;
standoffradius=7/2;
roundedcorner=6;
roundedcornerhole=3.0;
pcbthickness=1.2;


module standoff() {
    cylinder(h=standoffheight,r=standoffradius); // base


}

module standoffhole() {
    cylinder(h=standoffheight+1.6,r=2.0/2);  // hole piece
}

module roundedRect(size, radius)
{
	x = size[0]-radius;
	y = size[1]-radius;
   z = size[2];
   linear_extrude(height=z)
	hull()
	{
		// place 4 circles in the corners, with the given radius
		translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
	}
}

module mainbox() {

module makebox() {
translate( [boxlength/2, boxwidth/2, 0]) { // I dont want it centered
  roundedRect([boxlength+boxthickness,boxwidth+boxthickness,2],6);  //outside box bottom piece 2mm thick

  translate( [0,0,boxbottom]) //move 2mm up
  difference() {
    roundedRect([boxlength+boxthickness,boxwidth+boxthickness,boxheight],6);  //outside box
    roundedRect([boxlength,boxwidth,boxheight+0.1],5);  //inside box
  }
}

translate( [4.6*er,71.3*er,boxbottom]) standoff();
translate( [94.8*er,71.8*er,boxbottom]) standoff();
translate( [5.1*er,11.43*er,boxbottom]) standoff();
translate( [92.3*er,19.7*er+0.3,boxbottom]) standoff();

// lower left corner
difference() {
  translate( [roundedcorner/4+boxthickness/2,roundedcorner/4+boxthickness/2,boxbottom]) cylinder(h=boxheight, r=roundedcorner/2);
  translate( [roundedcorner/4+boxthickness/2,roundedcorner/4+boxthickness/2,boxbottom]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);
}

// lower right corner
difference() {
  translate( [boxlength-roundedcorner/4-boxthickness/2,roundedcorner/4+boxthickness/2,boxbottom]) cylinder(h=boxheight, r=roundedcorner/2);
  translate( [boxlength-roundedcorner/4-boxthickness/2,roundedcorner/4+boxthickness/2,boxbottom]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);
}

// upper right corner
difference() {
  translate( [boxlength-roundedcorner/4-boxthickness/2,boxwidth-roundedcorner/4-boxthickness/2,boxbottom]) cylinder(h=boxheight, r=roundedcorner/2);
  translate( [boxlength-roundedcorner/4-boxthickness/2,boxwidth-roundedcorner/4-boxthickness/2,boxbottom]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);
}

// upper left corner
difference() {
  translate( [roundedcorner/4+boxthickness/2,boxwidth-roundedcorner/4-boxthickness/2,boxbottom]) cylinder(h=boxheight, r=roundedcorner/2);
  translate( [roundedcorner/4+boxthickness/2,boxwidth-roundedcorner/4-boxthickness/2,boxbottom]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);
}

}

difference() {
  makebox();
  union() {
  translate( [4.6*er,71.3*er,boxbottom-1.5]) standoffhole();
  translate( [94.8*er,71.8*er,boxbottom-1.5]) standoffhole();
  translate( [5.1*er,11.43*er,boxbottom-1.5]) standoffhole();
  translate( [92.3*er,19.7*er+0.3,boxbottom-1.5]) standoffhole();

  translate([ (boxlength*er-74*er-9) /2-0.5 ,-3,boxbottom+standoffheight+pcbthickness]) cube([73*er+9,6,6.5]);  // front cutout

  translate([ (boxlength*er-74*er-9) /2-0.5 ,-3 +1.3,boxbottom+standoffheight+pcbthickness+6.5]) rotate([-45,0,0]) cube([73*er+9,6,6.5]);  // front cutout angled

  translate([ -1.8 ,51.8*er ,boxbottom+standoffheight+pcbthickness +3]) cube([6,11*er,6.5]);  // PSI cutout

  translate([ -1.8, 51.8*er, boxbottom+standoffheight+pcbthickness+6.5+3]) rotate([0,45,0]) cube([5,11*er,5]);  // PSI cutout angled

  translate([ 13.3*er -1,boxwidth-3,boxbottom+standoffheight+pcbthickness]) cube([78.5,6,14.9]);

/*
  translate([ 11.9*er ,boxwidth-3,boxbottom+standoffheight+1.6]) cube([37*er,6,14.9]);  // DB9 cutout  12.9 height

  translate([ 46.9*er ,boxwidth-3,boxbottom+standoffheight+1.6]) cube([37*er,6,14.9]);  // DB9 cutout  12.9 height

  translate([ 80.6*er ,boxwidth-3,boxbottom+standoffheight+1.6]) cube([9.9*er,6,14.5]);  // power cutout
*/
  translate([ -3 ,16*er,boxbottom+standoffheight+pcbthickness]) cube([6,23.4*er,5.5+1]);  // side cutout

  translate([ -1.8 ,16*er,boxbottom+standoffheight+pcbthickness+5.5]) rotate([0,45,0]) cube([6,23.4*er,6.5+1]);  // side cutout angled

 }
}

// add support to front cutout
translate([ (boxlength-86.6)/2 +25,-(boxthickness/2),boxbottom+standoffheight+pcbthickness]) cube([6,0.5,6.6]);

translate([ (boxlength-86.6)/2 +25,-(boxthickness/2)+0.5,boxbottom+standoffheight+pcbthickness+0.5]) cube([6,0.5,6.1]); // reinforce from behind

translate([ (boxlength-86.6)/2 +55,-(boxthickness/2),boxbottom+standoffheight+pcbthickness]) cube([6,0.5,6.6]);

translate([ (boxlength-86.6)/2 +55,-(boxthickness/2)+0.5,boxbottom+standoffheight+pcbthickness+0.5]) cube([6,0.5,6.1]);

}


rotate([0,0,90]) mainbox();
