
$fn = 30;
er=1.018; // expansion rate to counter ABS shrinkage
boxlength=100.6*er;
boxwidth=83.3*er;
boxheight=1.9;  // 12.8 serial height + 1.6mm PCB + 3mm stand off height = 17.9
boxthickness=8*0.44;
boxbottom=2;
standoffheight=3;
standoffradius=7/2;
roundedcorner=6;
roundedcornerhole=3.6;



module roundedRect(size, radius)
{
	x = size[0]-radius;
	y = size[1]-radius;
   z = size[2];
   linear_extrude(height=z)
	hull()
	{
		// place 4 circles in the corners, with the given radius
		translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
		circle(r=radius);
		
		translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
		
		translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
		circle(r=radius);
	}
}


module makebox() {

difference() {

translate( [boxlength/2, boxwidth/2, 0]) { // I dont want it centered
  roundedRect([boxlength+boxthickness,boxwidth+boxthickness,2],6);  //outside box bottom piece 2mm thick
}


// lower left corner

 
  translate( [roundedcorner/4+boxthickness/2,roundedcorner/4+boxthickness/2,0]) cylinder(h=boxheight+0.2, r=roundedcornerhole/2);


// lower right corner

  translate( [boxlength-roundedcorner/4-boxthickness/2,roundedcorner/4+boxthickness/2,0]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);


// upper right corner

  translate( [boxlength-roundedcorner/4-boxthickness/2,boxwidth-roundedcorner/4-boxthickness/2,0]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);


// upper left corner

  translate( [roundedcorner/4+boxthickness/2,boxwidth-roundedcorner/4-boxthickness/2,0]) cylinder(h=boxheight+0.1, r=roundedcornerhole/2);

// buzzer hole
  translate( [68,47,0]) cylinder(h=boxheight+0.1, r=4);


}

}

module words() {
    
    translate([-17,0,2]) rotate([0,0,90]) linear_extrude(height = 1) {
text("1",font = "Lucida Handwriting",size=6);
}

translate([-30,0,2]) rotate([0,0,90]) linear_extrude(height = 1) {
text("2",font = "Lucida Handwriting",size=6);
}

translate([0,13,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("4",font = "Lucida Handwriting",size=5);
}

translate([0,19,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("3",font = "Lucida Handwriting",size=5);
}

translate([0,28,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("External PSI",font = "Lucida Handwriting",size=6);
}

translate([0,50,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("Display",font = "Lucida Handwriting",size=6);
}

translate([0,65,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("WBO2",font = "Lucida Handwriting",size=5);
}

translate([0,71,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("Auxiliary",font = "Lucida Handwriting",size=5);
}

translate([0,80,2]) rotate([0,0,180]) linear_extrude(height = 1) {
text("Knob",font = "Lucida Handwriting",size=6);
}

translate([0,92,2]) rotate([0,0,180]) linear_extrude(height = 1.5) {
text("Solenoid",font = "Lucida Handwriting",size=6);
}
}


difference() {
  rotate([0,0,90]) color("green") makebox();
  //translate([0,0,-1]) words();
}